// $Id: sigName.C,v 1.3 1995/11/21 13:52:01 zeller Exp $
// Convert signal to name

// Copyright (C) 1995 Technische Universitaet Braunschweig, Germany.
// Written by Andreas Zeller (zeller@ips.cs.tu-bs.de).
// 
// This file is part of the DDD Library.
// 
// The DDD Library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// The DDD Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with the DDD Library -- see the file COPYING.LIB.
// If not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// DDD is the data display debugger.
// For details, see the DDD World-Wide-Web page, 
// `http://www.cs.tu-bs.de/softech/ddd/',
// or send a mail to the DDD developers at `ddd@ips.cs.tu-bs.de'.

char sigName_rcsid[] = 
    "$Id: sigName.C,v 1.3 1995/11/21 13:52:01 zeller Exp $";

#include "config.h"

#include <stddef.h>
#include <signal.h>
#include <sys/wait.h>
#include <strstream.h>

#include "strclass.h"
#include "sigName.h"

extern "C" char *strsignal(int signo);

// convert signal number into name
char *sigName(int signo)
{
    return strsignal(signo);
}


// convert wait() status into name
char *statusName(int status)
{
    static string s;

    s = "Unknown State Change";

    if (WIFEXITED(status))
    {
	ostrstream os;
	os << "Exit " << WEXITSTATUS(status);
        s = string(os);
    }
    else if (WIFSIGNALED(status))
        s = sigName(WTERMSIG(status));
    else if (WIFSTOPPED(status))
        s = sigName(WSTOPSIG(status));

    return (char *)s;
}
